module Delphi
# record field
  class Field
    attr_accessor :ident_list, :type
  end

  class Variant
    attr_accessor :expr_list, :type, :field_list
    def initialize
      @expr_list = []
    end
  end

  class VariantPart
    attr_accessor :ident, :type, :variant_list
    def initialize
      @variant_list = []
    end
  end

  class FieldList
    attr_accessor :fixed_list, :variant_part
    def initialize
      @fixed_list = []
    end
  end

# object field
  class ObjFieldList
    attr_accessor :ident_list, :type
  end

  class Param
    attr_accessor :ident_list, :type, :value
  end

  class Procedure
    attr_accessor :ident, :param_list, :directive
  end

  class Function
    attr_accessor :ident, :param_list, :type, :directive
  end

  class Constructor
    attr_accessor :ident, :param_list, :directive
  end

  class Destructor
    attr_accessor :ident, :param_list, :directive
  end

  class Property
    attr_accessor :ident, :param_list, :type
  end

  class Class
    attr_reader :herit, :field_list

    def initialize(herit=nil)
      @herit = herit
      @field_list = []
    end

    def add_field_list(visibility, field_list)
      field_list.each{|i|
#       on_obj_field visibility, i
        @field_list.push [visibility, i]
      }
    end

    def add_method_list(visibility, method_list)
      method_list.each{|i|
#       on_method visibility, i
        @field_list.push [visibility, i]
      }
    end

    def add_prop_list(visibility, prop_list)
      prop_list.each{|i|
#       on_prop visibility, i
        @field_list.push [visibility, i]
      }
    end
=begin
    def on_obj_field(visibility, i)
      p [visibility, i]
    end
    def on_method(visibility, i)
      p [visibility, i]
    end
    def on_prop(visibility, i)
      p [visibility, i]
    end
=end
  end

  class ClassRef
    attr_accessor :base
  end

  class PointerType
    attr_accessor :ref, :type
    def initialize
      @ref = []
    end
  end

  class OrdType
    attr_accessor :expr
  end

  class SubRangeType
    attr_accessor :begin_expr, :end_expr
  end

  class ArrayType
    attr_accessor :range, :type
    def initialize
      @range = []
    end
  end

  class StringType
    attr_accessor :type
  end

  class EnumTypeItem
    attr_accessor :ident, :value
  end

  class EnumType
    attr_accessor :items
    def initialize
      @items = []
    end
  end

  class FileType
    attr_accessor :type
  end

  class SetType
    attr_accessor :type
  end

  class ProcedureType
    attr_accessor :ident, :param_list, :directive
  end

  class FunctionType
    attr_accessor :ident, :param_list, :type, :directive
  end

  class Const
    attr_accessor :ident, :type, :value, :directive
  end

  class Type
    attr_reader :ident, :value, :directive
    def initialize(ident, value, direc)
      @ident = ident
      @value = value
      @directive = direc
    end
  end

  class Var
    attr_accessor :ident_list, :type, :directive, :absolute, :value
  end

  class Interface
    attr_reader :uses, :types, :consts, :resourcestrings, :vars, :threadvars, :procedures
    def initialize
      @uses = []
      @types = []
      @consts = []
      @resourcestrings = []
      @vars = []
      @threadvars = []
      @procedures = []
    end
  end

  class Unit
    attr_accessor :ident, :interface
  end
end

